<cfcomponent>

	<cffunction name="Create" access="public" output="false">
		<cfargument name="Contact" required="yes" />
		<cfset var CreateQuery = "" />
	
			<cfquery name="CreateQuery" datasource="#getAppConfig().getConfig().dsn#">
	
				INSERT INTO Contact
				( ContactName, ContactTypeID ) 
				VALUES
				( 
					<cfqueryparam value="#arguments.Contact.getContactName()#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#val( arguments.Contact.getContactTypeID() )#" cfsqltype="cf_sql_numeric">					
				)			
	
			</cfquery>
		
	</cffunction>

	<cffunction name="Read" access="public" output="false">
		<cfargument name="Contact" required="yes" />
		<cfset var ReadQuery = "" />
		
		<cfquery name="ReadQuery" datasource="#getAppConfig().getConfig().dsn#">
	
			SELECT ContactID, ContactName, ContactTypeID
			FROM Contact
			WHERE ContactID = <cfqueryparam value="#val( arguments.Contact.getContactID() )#" cfsqltype="cf_sql_numeric">
	
		</cfquery>

		<cfset arguments.Contact.setContactID( ReadQuery.ContactID ) />
		<cfset arguments.Contact.setContactName( ReadQuery.ContactName ) />
		<cfset arguments.Contact.setContactTypeID( ReadQuery.ContactTypeID ) />

	</cffunction>

	<cffunction name="Update" access="public" output="false">
		<cfargument name="Contact" required="yes" />
		<cfset var UpdateQuery = "" />
		
		<cfquery name="UpdateQuery" datasource="#getAppConfig().getConfig().dsn#">
	
			UPDATE Contact
				SET 
					ContactName = <cfqueryparam value="#arguments.Contact.getContactName()#" cfsqltype="cf_sql_varchar">,
					ContactTypeID = <cfqueryparam value="#arguments.Contact.getContactTypeID()#" cfsqltype="cf_sql_numeric">
			WHERE ContactID = <cfqueryparam value="#arguments.Contact.getContactID()#" cfsqltype="cf_sql_numeric">
				
		</cfquery>		
	
	</cffunction>

	<cffunction name="Delete" access="public" output="false">
		<cfargument name="Contact" required="yes" />
		<cfset var DeleteQuery = "" />
		
		<cfquery name="DeleteQuery" datasource="#getAppConfig().getConfig().dsn#">
	
			DELETE FROM Contact
			WHERE contactID = <cfqueryparam value="#arguments.Contact.getContactID()#" cfsqltype="cf_sql_numeric">
	
		</cfquery>
	
	</cffunction>


	<cffunction name="getAppConfig" access="public" output="false" returntype="any">
		<cfreturn variables.instance.AppConfig />
	</cffunction>
	
	<cffunction name="setAppConfig" access="public" output="false" returntype="void">
		<cfargument name="AppConfig" type="any" required="true" />
		<cfset variables.instance.AppConfig = arguments.AppConfig />
	</cffunction>
	
	
	

</cfcomponent>